app/models.py
from app import db
from datetime import datetime
import re

from email_validator import validate_email
from flask_security import UserMixin, RoleMixin


def slugify(s):
    pattern = r'[^\w+]'
    return re.sub(pattern, '-', s)


post_tags = db.Table('post_tags',
                     db.Column('post_id', db.Integer, db.ForeignKey('post.id')),
                     db.Column('tag_id', db.Integer, db.ForeignKey('tag.id'))
                     )


class Post(db.Model):
    id = db.Column(db.Integer, primary_key=True)
    title = db.Column(db.String(140))
    slug = db.Column(db.String(140), unique=True)
    body = db.Column(db.Text)
    created = db.Column(db.DateTime, default=datetime.now())

    def __init__(self, *args, **kwargs):
        super(Post, self).__init__(*args, **kwargs)
        self.generate_slug()

    tags = db.relationship('Tag', secondary=post_tags, backref=db.backref('posts', lazy='dynamic'))

    def generate_slug(self):
        if self.title:
            self.slug = slugify(self.title)

    def __repr__(self):
        return '<Post id: {}, title: {}>'.format(self.id, self.title)


class Tag(db.Model):
    id = db.Column(db.Integer, primary_key=True)
    name = db.Column(db.String(100))
    slug = db.Column(db.String(100))

    def __init__(self, *args, **kwargs):
        super(Tag, self).__init__(*args, **kwargs)
        self.slug = slugify(self.name)

    def __repr__(self):
        return '{}'.format(self.name)


# Flask security
roles_users = db.Table('roles_users',
                       db.Column('user_id', db.Integer, db.ForeignKey('user.id')),
                       db.Column('role_id', db.Integer, db.ForeignKey('role.id'))
                       )


class User(db.Model, UserMixin):
    id = db.Column(db.Integer(), primary_key=True)
    email = db.Column(db.String(100), unique=True)
    password = db.Column(db.String(255))
    active = db.Column(db.Boolean())
    roles = db.relationship('Role', secondary=roles_users, backref=db.backref('users', lazy='dynamic'))


class Role(db.Model, RoleMixin):
    id = db.Column(db.Integer(), primary_key=True)
    name = db.Column(db.String(100), unique=True)
    description = db.Column(db.String(255))

app/posts/forms.py
from wtforms import Form, StringField, TextAreaField


class PostForm(Form):
    title = StringField('Title')
    body = TextAreaField('Body')

app/app.py
from flask import Flask
from flask import redirect, url_for, request
from config import Configuration
from flask_sqlalchemy import SQLAlchemy
from flask_migrate import Migrate, MigrateCommand
from flask_script import Manager
from flask_admin import Admin, AdminIndexView
from flask_admin.contrib.sqla import ModelView
from flask_security import SQLAlchemySessionUserDatastore, Security, current_user

app = Flask(__name__)
app.config.from_object(Configuration)

db = SQLAlchemy(app)

migrate = Migrate(app, db)
manager = Manager(app)
manager.add_command('db', MigrateCommand)

### ADMIN ###
from models import *


class AdminMixin:
    def is_accessible(self):
        return current_user.has_role('admin')

    def inaccessible_callback(self, name, **kwargs):
        return redirect(url_for('security.login', next=request.url))


class BaseModelView(ModelView):
    def on_model_change(self, form, model, is_created):
        model.generate_slug()
        return super(BaseModelView, self).on_model_change(form, model, is_created)


class AdminView(AdminMixin, ModelView):
    pass


class HomeAdminView(AdminMixin, AdminIndexView):
    pass


class PostModelView(AdminMixin, BaseModelView):
    form_columns = ['title', 'body', 'tags']


class TagModelView(AdminMixin, BaseModelView):
    form_columns = ['name', 'posts']


admin = Admin(app, 'FlaskApp', url='/', index_view=HomeAdminView(name='Home'))
admin.add_view(PostModelView(Post, db.session))
admin.add_view(TagModelView(Tag, db.session))

### Flask-security ###
user_datastore = SQLAlchemySessionUserDatastore(db.session, User, Role)
security = Security(app, user_datastore)

app/main.py
from app import app
from app import db

from posts.blueprint import posts

import view


app.register_blueprint(posts, url_prefix='/blog')


if __name__ == '__main__':
    app.run(debug=True)

app/posts/blueprint.py
from flask import Blueprint
from flask import render_template
from flask import request
from flask import redirect
from flask import url_for

from models import Post, Tag
from .forms import PostForm
from app import db

from flask_security import login_required

posts = Blueprint('posts', __name__, template_folder='templates')


@posts.route('/create', methods=['POST', 'GET'])
@login_required
def create_post():

    if request.method == 'POST':
        title = request.form['title']
        body = request.form['body']

        try:
            post = Post(title=title, body=body)
            db.session.add(post)
            db.session.commit()
        except:
            print('Something was wrong')

        return redirect(url_for('posts.index'))
    else:
        form = PostForm()
        return render_template('posts/create_post.html', form=form)


@posts.route('<slug>/edit/', methods=['POST', 'GET'])
@login_required
def edit_post(slug):
    post = Post.query.filter(Post.slug == slug).first_or_404()

    if request.method == 'POST':
        form = PostForm(formdata=request.form, obj=post)
        form.populate_obj(post)
        db.session.commit()

        return redirect(url_for('posts.post_detail', slug=post.slug))

    form = PostForm(obj=post)
    return render_template('posts/edit_post.html', post=post, form=form)


@posts.route('/')
def index():

    q = request.args.get('q')

    page = request.args.get('page')
    if page and page.isdigit():
        page = int(page)
    else:
        page = 1

    if q:
        posts = Post.query.filter(Post.title.contains(q) | Post.body.contains(q))
    else:
        posts = Post.query.order_by(Post.created.desc())

    pages = posts.paginate(page=page, per_page=5)

    return render_template('posts/index.html', pages=pages)

@posts.route('/<slug>')
def post_detail(slug):
    post = Post.query.filter(Post.slug == slug).first_or_404()
    tags = post.tags
    return render_template('posts/post_detail.html', post=post, tags=tags)

@posts.route('/tag/<slug>')
def tag_detail(slug):
    tag = Tag.query.filter(Tag.slug == slug).first_or_404()
    posts = tag.posts.all()
    return render_template('posts/tag_detail.html', tag=tag, posts=posts)

app/posts/templates/posts/create_post.html
{% extends 'base.html' %}

{% block title %}
    Create new post
{% endblock %}

{% block content_title %}
    New post
{% endblock %}

{% block content %}
    <div class="col-md-6">
        <form action="{{ url_for('posts.create_post') }}" method="POST">
            {% for field in form %}
                <div class="form-group">
                    {{ field.label(class='control-label') }}
                    {{ field(class='form-control') }}
                </div>
            {% endfor %}

            <button type="submit" class="btn btn-success">Create</button>
        </form>
    </div>
{% endblock %}

app/posts/templates/posts/edit_post.html
{% extends 'base.html' %}

{% block title %}
    Edit post
{% endblock %}

{% block content_title %}
    Edit post
{% endblock %}

{% block content %}
    <div class="col-md-6">
        <form action="{{ url_for('posts.edit_post', slug=post.slug) }}" method="POST">
            {% for field in form %}
                <div class="form-group">
                    {{ field.label(class='control-label') }}
                    {{ field(class='form-control') }}
                </div>
            {% endfor %}

            <button type="submit" class="btn btn-success">Edit</button>
        </form>
    </div>
{% endblock %}

app/posts/templates/posts/index.html
{% extends 'base.html' %}

{% block title %}
Blueprint index page
{% endblock %}

{% block content_title %}
Posts
{% endblock %}

{% block content %}
{% for post in pages.items %}
    <p>
        <a href="{{ url_for('posts.post_detail', slug=post.slug) }}">{{ post.title }}</a>
</p>
{% endfor %}

<nav>
    <ul class="pagination">
        <li {% if not pages.has_prev %} class="disabled" {% endif %}>
            <a href="./?page={{ pages.prev_num }}" aria-label="Previous"><span aria-hidden="true">&laquo;</span></a>
        </li>

        {% for page in pages.iter_pages() %}
            <li  {% if page == pages.page %} class="active" {% endif %}>
                <a  href="./?page={{ page }}"> {{ page }} <span class="sr-only">(current)</span></a>
            </li>
        {% endfor %}


        <li {% if not pages.has_next %} class="disabled" {% endif %}>
            <a href="./?page={{ pages.next_num }}" aria-label="Next"><span aria-hidden="true">&raquo;</span></a>
        </li>
    </ul>
</nav>
{% endblock %}

app/posts/templates/posts/post_detail.html
{% extends 'base.html' %}

{% block title %}
    {{ post.title }}
{% endblock %}

{% block content_title %}
    {{ post.title }}

{% endblock %}

{% block content %}
    <div class="tags">
        {% for tag in tags %}
            <a href="{{ url_for('posts.tag_detail', slug=tag.slug) }}">
                <span class="label label-primary">{{ tag.name }}</span>
            </a>
        {% endfor %}
    </div>
    <div class="main-content">
        {{ post.body }}
    </div>
{% endblock %}

app/posts/templates/posts/tag_detail.html
{% extends 'base.html' %}

{% block title %}
    {{ tag.name }} posts
{% endblock %}

{% block content_title %}
    Posts for {{ tag.title }} tag

{% endblock %}

{% block content %}
    {% for post in posts %}
        <div class="post">
            <a href="{{ url_for('posts.post_detail', slug=post.slug) }}">{{ post.title }}</a>
        </div>
    {% endfor %}
{% endblock %}

app/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css"
          integrity="sha384-HSMxcRTRxnN+Bdg0JdbxYKrThecOKuH5zCYotlSAcp1+c8xmyTe9GYg1l9a69psu" crossorigin="anonymous">
    <title>
        {% block title %}

        {% endblock %} | Flask app
    </title>
</head>
<body>
    <nav class="navbar navbar-default">
      <div class="container-fluid">
        <!-- Brand and toggle get grouped for better mobile display -->
        <div class="navbar-header">
          <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1" aria-expanded="false">
            <span class="sr-only">Toggle navigation</span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
          <a class="navbar-brand" href="{{ url_for('index') }}">Flask</a>
        </div>

        <!-- Collect the nav links, forms, and other content for toggling -->
        <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
          <ul class="nav navbar-nav">
            <li class="active"><a href="{{ url_for('posts.index') }}">Blog<span class="sr-only">(current)</span></a></li>
            <li><a href="#">Link</a></li>
          </ul>

          <form class="navbar-form navbar-left" method="GET">
            <div class="form-group">
              <input type="text" class="form-control" placeholder="Search" name="q" value="{{ request.args.get('q', '') }}">
            </div>
            <button type="submit" class="btn btn-default">Submit</button>
          </form>

          <ul class="nav navbar-nav navbar-right">
<!--            <li><a href="{{ url_for('posts.create_post') }}">New post</a></li>-->
              <li>
                  {% if current_user.has_role('admin') %}
                  <a href="/admin">Admin</a>
                  {% endif %}
              </li>
          </ul>
        </div><!-- /.navbar-collapse -->
      </div><!-- /.container-fluid -->
    </nav>

    <div class="container">
        <h1>
            {% block content_title %}

            {% endblock %}
        </h1>
        <div class="row">
            {% block content %}

            {% endblock %}
        </div>
    </div>
</body>
</html>

app/templates/index.html
{% extends 'base.html' %}

{% block title %}
    Index page
{% endblock %}

{% block content_title %}
    Index page
{% endblock %}

{% block content %}
    Some content
{% endblock %}

app/templates/security/_messages.html
{%- with messages = get_flashed_messages(with_categories=true) -%}
  {% if messages %}
    <div class="flashes">
    {% for category, message in messages %}
      <div class="alert alert-{{ category }}">{{ message }}</div>
    {% endfor %}
    </div>
  {% endif %}
{%- endwith %}

app/templates/security/login_user.html
{% extends 'base.html' %}

{% block title %}
    Login
{% endblock %}

{% block content_title %}
    {{ _('Login') }}
{% endblock %}


{% block content %}
  <div class="col-md-offset-3 col-md-6">
    {% from "security/_macros.html" import render_field_with_errors, render_field %}
    {% include "security/_messages.html" %}
    <form action="{{ url_for_security('login') }}" method="POST" name="login_user_form">
      {{ login_user_form.hidden_tag() }}
      {{ render_field_with_errors(login_user_form.email, class = 'form-control') }}
      {{ render_field_with_errors(login_user_form.password, class = 'form-control') }}
      {{ render_field_with_errors(login_user_form.remember) }}
      {{ render_field(login_user_form.next) }}
      {{ render_field(login_user_form.submit, class = 'btn btn-success') }}
    </form>
    {% include "security/_menu.html" %}
  </div>
{% endblock %}